﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using rfid;

namespace ConsoleApplication1
{
  class Program
  {
    static string MakeStringFromArray(sbyte[] Arr, int StringNummer)
    {
      string strLine;
      strLine = "";

      int i = 0;
      for (int aktStringNummer = 0; aktStringNummer <= StringNummer; aktStringNummer++)
      {
        strLine = "";
        for (; (i < Arr.Length); i++)
        {
          if (Arr[i] == 0)
          {
            break;
          }
          strLine += (char)Arr[i];
        }
        i++;
        if (strLine.Length == 0)
          break;
      }
      return strLine;
    }

    static sbyte[] MakeArrayFromString(string Name)
    {
      sbyte[] arr = new sbyte[Name.Length+1];
      int i = 0;
      for (i = 0; i < Name.Length; i++)
        arr[i] = (sbyte)Name[i];
      arr[i] = 0;
      return arr;
    }

    static string MakeStringFromArray(SByte[] Arr)
    {
      string strLine;
      strLine = "";

      for (int i = 0; (i < Arr.Length) && (Arr[i] != 0); i++)
      {
        strLine += (char)Arr[i];
      }
      return strLine;
    }

    static string MakeStringFromArray(Byte[] Arr)
    {
      string strLine;
      strLine = "";

      for (int i = 0; (i < Arr.Length) && (Arr[i] != 0); i++)
      {
        strLine += (char)Arr[i];
      }
      return strLine;
    }

    static void CopyArrayTo(Byte[] Src, int SrcOffset, Byte[] Dest, int DestOffset, int Len)
    {
      while (Len > 0)
      {
        Dest[DestOffset++] = Src[SrcOffset++];
        Len--;
      }
    }
    static void CopyArrayTo(SByte[] Src, int SrcOffset, SByte[] Dest, int DestOffset, int Len)
    {
      while (Len > 0)
      {
        Dest[DestOffset++] = Src[SrcOffset++];
        Len--;
      }
    }


    static void Main(string[] args)
    {
      int MaxLen = 255;
      int ReadLen = 0;
      int ListLen = 0;
      int DevListLen;

      int Version;
      int TagCount;
      int DeviceCount;

      SByte[] NamenListe = new SByte[1000];
      SByte[] DevList = new SByte[MaxLen];

      Console.Out.Write("C Sharp Test App for TS-HRW38");
      Console.Out.WriteLine();
      Console.Out.WriteLine();

      Version = GIS_HRW_API.TSHRW_LibVersion();
      Console.Out.Write("Lib Version: ");
      Console.Out.Write(Version);
      Console.Out.WriteLine();

      DevListLen = GIS_HRW_API.TSHRW_GetAvailablePorts(DevList, MaxLen)-1;
      CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen);
      ListLen += DevListLen;
      DevListLen = GIS_HRW_API.TSHRW_ListAllDeviceNames(DevList, MaxLen)-1;
      CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen);
      ListLen += DevListLen;
      DevListLen = GIS_HRW_API.TSHRW_LanListAllDeviceNames(DevList, MaxLen)-1;
      CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen);
      ListLen += DevListLen;
      ListLen++;

      if (ListLen > 1)
      {
        string DeviceName;
        int DeviceNr;

        Console.Out.Write("Device found ");
        DeviceCount = 0;
        do
        {
          DeviceName = MakeStringFromArray(NamenListe, DeviceCount);
          if (DeviceName.Length > 0)
          {
            Console.Out.Write("Device {0,0:D} ", DeviceCount + 1);
            Console.Out.Write(DeviceName);
            Console.Out.WriteLine();
          }
          DeviceCount++;
        }
        while (DeviceName.Length > 0);

        Console.Out.Write("Select Device:");
        DeviceNr = Convert.ToInt32(Console.In.ReadLine());

        DeviceName = MakeStringFromArray(NamenListe, DeviceNr - 1);
        SByte[] DeviceNameArr = MakeArrayFromString(DeviceName);

        Console.Out.Write("Open Device: ");
        Console.Out.Write(DeviceName);
        Console.Out.WriteLine();

        // open with high baudrate suitable for Medio P200u
        int Handle = GIS_HRW_API.TSHRW_OpenPort(DeviceNameArr, 115200, 500);
        if (Handle < 0)
        {
          // if not opened try again with standard baudrate
          Handle = GIS_HRW_API.TSHRW_OpenPort(DeviceNameArr, 19200, 500);
        }

        if (Handle > 0)
        {
          int BlockNr;
          Byte[] DevVer = new Byte[4];

          if (GIS_HRW_API.TSHRW_DeviceVersion(Handle, DevVer, 4) == 4)
          {
            Console.Out.Write(MakeStringFromArray(DevVer));
            Console.Out.WriteLine();
          }

          if (GIS_HRW_API.TSHRW_IsProgrammer(Handle) != 1)
          {
            Console.Out.Write("Connected Device does not support Programmer mode! Please check Device!");
            Console.Out.WriteLine();
          }
          else
          { 
            if (GIS_HRW_API.TSHRW_SetRF(Handle, 1) < 0)
            {
              Console.Out.Write("Error at SetRF");
              Console.Out.WriteLine();
            }

            Byte[] Data = new Byte[11 * 24]; // Inventory of up to 24 chips
            Byte[] UID = new Byte[8];
            Byte[] BlockData = new Byte[16];

            ReadLen = GIS_HRW_API.TSHRW_ISO_Inventory(Handle, Data, 11 * 24, 0);
            if (ReadLen < GIS_HRW_API.TSHRW_NO_ERROR)
            {
              Console.Out.Write("Error at Inventory");
              Console.Out.WriteLine();
              TagCount = 0;
            }
            else
            {
              Console.Out.Write("ReadLen {0,2:D} ", ReadLen);
              Console.Out.WriteLine();
              TagCount = ReadLen / 11; // For each Tag found 11 Bytes are returned
              for (int i = 0; i < TagCount; i++)
              {
                Console.Write("Tag[{0,0:D2}] ", i);
                Console.Out.Write("{0,0:X2}{1,0:X2}{2,0:X2}{3,0:X2}{4,0:X2}{5,0:X2}{6,0:X2}{7,0:X2}", Data[i * 11 + 10], Data[i * 11 + 9], Data[i * 11 + 8], Data[i * 11 + 7], Data[i * 11 + 6], Data[i * 11 + 5], Data[i * 11 + 4], Data[i * 11 + 3]);
                Console.Out.WriteLine();
              }
            }

            if (TagCount > 0)
            {
              for (int i = 0; i < TagCount; i++)
              {
                CopyArrayTo(Data, i * 11 + 3, UID, 0, 8);
                Console.Out.Write("Read [");
                Console.Out.Write("{0,0:X2}{1,0:X2}{2,0:X2}{3,0:X2}{4,0:X2}{5,0:X2}{6,0:X2}{7,0:X2}", UID[7], UID[6], UID[5], UID[4], UID[3], UID[2], UID[1], UID[0]);
                Console.Out.Write("] = ");
                BlockNr = 0;
                int BlockLength = GIS_HRW_API.TSHRW_ISO_ReadSingleBlock(Handle, BlockNr, BlockData, BlockData.Length, UID, 8, 0);
                //int BlockLength = GIS_HRW_API.TSHRW_ISO_ReadMultipleBlocks(Handle, BlockNr, 4, BlockData, BlockData.Length, UID, 8, 0);
                if (BlockLength < GIS_HRW_API.TSHRW_NO_ERROR)
                {
                  Console.Out.Write("Error ");
                }
                else
                {
                  for (int j = 0; j < BlockLength; j++)
                    Console.Out.Write("{0,0:X2} ", BlockData[j]);
                }
                Console.Out.Write("done");
                Console.Out.WriteLine();
              }
            }
            else
            {
              Console.Out.Write("no Tag found ");
              Console.Out.WriteLine();
            }
          }
          GIS_HRW_API.TSHRW_ClosePort(Handle);
        }
        else
        {
          Console.Out.Write("Error ");
          Console.Out.Write(Handle);
          Console.Out.Write(" at TSHRW_OpenPort");
          Console.Out.WriteLine();
        }
      }
      else
      {
        Console.Out.Write("No Device found");
        Console.Out.WriteLine();
      }
      Console.Out.Write("Wait for Key to exit");
      while (!Console.KeyAvailable) ;
    }
  }
}
